% Required for the Matlab code example for Algorithm 1 presented in
% "Sparse FFT for Functions with Short Frequency Support" by Sina Bittens

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [d, a, b] = exgcd(x,y)
%EXGCD Extended Euclidean Algorithm. For integers x and y find the greatest 
% common divisor d and integers a and b such that d=gcd(x,y)=a*x+b*y.

% Test whether x and y are integers.
if ((abs(round(x)-x)) > eps('double')) || ((abs(round(y)-y)) > eps('double'))
    disp('a and b have to be integers')
else
    % If y=0, the greatest common divisor of x and y is x=1*x+0*y
    if y==0
        d=x; a=1; b=0;
    else
        % Call exgcd recursively to find the greatest common divisor and 
        % adapt a1 and b1 to obtain d=a*x+b*y.
        [d1,a1,b1]=exgcd(y, mod(x,y));
        d=d1; a=b1; b=a1-floor(x/y)*b1;
    end
end
end

