% Required for the Matlab code example for Algorithm 1 presented in
% "Sparse FFT for Functions with Short Frequency Support" by Sina Bittens

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [p_q] = qthprime(a)
%QTHPRIME Returns the smallest prime p_q such that p_(q-1)<=a<p_q, 
% where p_q is the q-th prime.

% If a=1 set p_q=2.
if a==1
    p_q=2;
else
    % For all a>1 one can consider the vector w consisting of the primes 
    % smaller than or equal to a.
    w=primes(a);
    % The last entry, w(end), is the q-1-th prime p_(q-1) and the q-th 
    % prime p_q is the smallest prime greater than w(end).
    p_q=nprimes(1,w(end)+1);
end
end